import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.SwingUtilities;

public class Problem1 extends JComponent {
    // position of rectangle
    protected int x = 20;
    protected int y = 100;
        
    public Problem1() {
    }
    
    // draw a gray rectangle at (x,y)
    public void paint(Graphics g) {
        super.paint(g);
        
        Graphics2D g2d = (Graphics2D) g;
        g2d.setPaint(Color.DARK_GRAY);
        g2d.fillRect(x, y, 80, 50);
    }
    
    // animate the rectangle by moving it 
    // every 100 ms
    public void animate() {
        int startX = 20;
        int endX = 220;
        
        for (x = startX; x < endX; ++x) {
            paintImmediately();
            try {
                Thread.sleep(10);
            } catch (InterruptedException e) {
            }
        }
        repaint();
    }
    
    public void paintImmediately() {
        Dimension size = getSize();
        paintImmediately(0, 0, size.width, size.height);
    }
        
    // main: create a test window
    public static void main(String[] args) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run () {
                makeFrame("Problem 1", new Problem1());
            }
        });
    }
    
    public static void makeFrame(String title, final Problem1 problem) {
        final JFrame frame = new JFrame(title);
        
        JMenuBar menubar = new JMenuBar();
        JMenu fileMenu = new JMenu("File");
        JMenuItem exitItem = new JMenuItem("Exit");
        exitItem.addActionListener(new ActionListener() {
           public void actionPerformed(ActionEvent event) {
                System.exit(0);
            } 
        });
        fileMenu.add(exitItem);
        menubar.add(fileMenu);
        
        frame.setJMenuBar(menubar);
        
        frame.getContentPane().add(problem);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setSize(320, 300);
        frame.setVisible(true);                

        frame.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent event) {
                problem.animate();
            } 
        });
    }
}
